function love.load()
	--CONFIGURABLE VARIABLES--
	
	windowwidth = 640
	windowheight = 480
	
	speed = 0.15 				--lower = faster
	height = 100 				--start height
	position = 0.5 				--starting position
	
	--Horizontal movement
	sideaccel = 25 				--horizontal acceleration
	maxsidespeed = 10 			--maximal horizontal speed
	autobreak = 4 				--amount of smootness after letting go of left/right
	maxangle = 0.5 				--angle when sidespeed = maxsidespeed
	
	barrelrollrotspeed = 7 		--effectively setting the duration
	barrelrollmaxspeed = 15		--also influences rotation
	barrelrollaccel = 40		--always at full effect when barrelrolling
	barrelrolldelay = 0.2		--seconds between 2 left or right presses that'll trigger the barrel roll
	
	--Vertical Movement
	heightaccel = 105 			--vertical acceleration
	maxheightspeed = math.pi*100 		--maximal vertical speed
	heightspeedgradient = 60 	--height from max or min where plane will start going horizontal again.
	deadzone = 0.05				--the heightspeed where it'll skip to 0
	heightbreak = 10				--amount of smoothness after letting go of up/down, used as well in the gradient above
	minheight = 5				--
	maxheight = 2000			--
	
	--Design
	verticallines = 200			--amount of vertical lines to draw at each side from center
	ystartadd = 250				--horizont (for heightspeed = 0)
	mountainspeed1 = 50			--front row (lower = faster)
	mountainspeed2 = 80			--back row (lower = faster)
	horizontupdaterate = 0		--updates the hud variables (rotation, ystart) every x seconds only
	redstart = 50				--height where the altitude display will start getting red (completely red at minheight)
	ystartheightoffset = 1		--how much the height influences the ystart offset

	--Colors
	color1 = {50,150,70} 				--0 - 1
	color2 = {78,192,98} 				--1 - 2
	linecolor = {255,255,255, 200}		--vertical and horizontal lines
	hudcolor = {255, 255, 255, 200}		--white
	--hudcolor = {180, 255, 40, 150}	--limegreen
	--hudcolor = {255, 50, 50, 150}		--red
	love.graphics.setBackgroundColor(160,194,247)
	
	
	
	
	--UNCONFIGURABLE VARIABLES--
	tick = 0
	sidespeed = 0
	heightspeed = 0
	
	maxheightplus = maxheightspeed
	maxheightminus = maxheightspeed
	
	obstacletable = {}
	for i = 1, 23 do
		obstacletable[i] = nil
	end
	
	leftbarreltimer = 0
	rightbarreltimer = 0
	barrelroll = false
	
	oldtimer = love.timer.getTime() - horizontupdaterate --so it updates at the start
	
	allowraise = false --for the table moving
	
	--IMAGES & FONTS--
	
	fontpure = love.graphics.newFont( "graphics/Pure-Capital.ttf", 26 )
	love.graphics.setFont(fontpure)
	
	mountains1 = love.graphics.newImage("graphics/mountains1.png");mountains1:setFilter("nearest","nearest")
	mountains2 = love.graphics.newImage("graphics/mountains2.png");mountains2:setFilter("nearest","nearest")
	sky = love.graphics.newImage("graphics/sky.png");sky:setFilter("nearest","nearest")
	tree = love.graphics.newImage("graphics/tree.png");tree:setFilter("nearest","nearest")
	
	gradient = love.graphics.newImage("graphics/gradient.png")
	
	--hud
	hudstatic = love.graphics.newImage("graphics/hud/static.png");hudstatic:setFilter("nearest","nearest")
	hudhorizont = love.graphics.newImage("graphics/hud/horizont.png");hudhorizont:setFilter("nearest","nearest")
	hudheight = love.graphics.newImage("graphics/hud/heightbar.png");hudheight:setFilter("nearest","nearest")
	hudjet = love.graphics.newImage("graphics/hud/jet.png");hudjet:setFilter("nearest","nearest")
end

function love.update(dt)
	tick = tick + (1 + heightspeed*0.005) * dt
	
	--Moving the table for obstacletable
	if math.mod(tick, speed) > speed/2 then
		allowraise = true
	elseif allowraise == true then
		allowraise = false
		movetable()
	end
	
	--left and right
	if barrelroll == false then
		if love.keyboard.isDown("left") and sidespeed > -maxsidespeed then
			if sidespeed > -maxsidespeed + sideaccel*dt then
				sidespeed = sidespeed - sideaccel*dt
			else
				sidespeed = -maxsidespeed
			end
		elseif love.keyboard.isDown("right") and sidespeed < maxsidespeed then
			if sidespeed < maxsidespeed - sideaccel*dt then
				sidespeed = sidespeed + sideaccel*dt
			else
				sidespeed = maxsidespeed
			end
		else
			if love.keyboard.isDown("left") == false and love.keyboard.isDown("right") == false or sidespeed < -maxsidespeed or sidespeed > maxsidespeed then
				sidespeed = sidespeed - (autobreak*sidespeed*dt)
			end
		end
		
		if math.abs(sidespeed) < deadzone and love.keyboard.isDown("left") == false and love.keyboard.isDown("right") == false then
			sidespeed = 0
		end
		
		rotation = -(sidespeed/maxsidespeed)*maxangle
	end
	
	--barrelroll
	if barrelroll == "left" then
		if sidespeed > -barrelrollmaxspeed then
			sidespeed = sidespeed - barrelrollaccel*dt
		end
		if rotation < math.pi*1.5 then
			rotation = rotation + barrelrollrotspeed*dt
		else
			if rotation < -(sidespeed/maxsidespeed)*maxangle+math.pi*2 then
				rotation = rotation + barrelrollrotspeed*dt
			else
				barrelroll = false
			end
		end
		
	elseif barrelroll == "right" then
		if sidespeed < barrelrollmaxspeed then
			sidespeed = sidespeed + barrelrollaccel*dt
		end
		if rotation > -math.pi * 1.5 then
			rotation = rotation - barrelrollrotspeed*dt
		else
			if rotation > -(sidespeed/maxsidespeed)*maxangle-math.pi*2 then
				rotation = rotation - barrelrollrotspeed*dt
			else
				barrelroll = false
			end
		end
		
	end
	
	--Up and down
	
	if love.keyboard.isDown("up") and heightspeed > -maxheightminus  and height ~= minheight then
		heightspeed = heightspeed - heightaccel*dt
	elseif love.keyboard.isDown("down") and heightspeed < maxheightplus and height ~= maxheight then
		heightspeed = heightspeed + heightaccel*dt
	elseif (height == maxheight or height == minheight)  then
		heightspeed = heightspeed - (heightbreak*heightspeed*dt*0.5)
	elseif love.keyboard.isDown("up") == false and love.keyboard.isDown("down") == false or (heightspeed > maxheightplus and height > maxheight - heightspeedgradient) or (heightspeed < maxheightminus and height < heightspeedgradient + minheight) then
		heightspeed = heightspeed - (heightbreak*heightspeed*dt*0.5)
	end 
	
	if math.abs(heightspeed) < deadzone and love.keyboard.isDown("left") == false and love.keyboard.isDown("right") == false then
		heightspeed = 0
	end
	
	height = height + heightspeed * dt
	
	if height < minheight then
		height = minheight
	end
	
	if height > maxheight then
		height = maxheight
	end
	
	--Math!
	
	position = position + sidespeed * dt
	
	lowerwidth = 20+(1 - heightspeed / (math.pi*200))*(10000/height)
	upperwidth = 20
	cellheight = 2.5-(height*0.002)
	ystart = (heightspeed+ystartadd+((height/2)*ystartheightoffset))
	mountain2offset = -13.5-- + height/100
	if height < 312.5 then
		gradientalpha = (height-100)*1.2
	else
		gradientalpha = 255
	end
	
	if maxheight - height < heightspeedgradient then
		maxheightplus = maxheightspeed*((maxheight-height)/heightspeedgradient)
	end
	
	if height < minheight+heightspeedgradient then
		maxheightminus = maxheightspeed*((height-minheight)/heightspeedgradient)
	end
	
	if gradientalpha < 0 then
		gradientalpha = 0
	end
	
	--delaying the hud
	
	currenttime = love.timer.getTime()
	if currenttime - oldtimer > horizontupdaterate then
		oldystart = ystart
		oldrotation = rotation
		oldtimer = currenttime
	end
end

function love.draw()
	--love.graphics.scale( 2.625, 2.1875 ) --for 1680x1050
	--rotate shit
    love.graphics.translate(windowwidth/2, 240)--ystart)
    love.graphics.rotate(rotation)
    love.graphics.translate(-windowwidth/2, -240)---ystart)
	
	--sky
	for i = -2, 2 do
		love.graphics.draw(sky, 412*i-math.mod(position+170, mountainspeed2)*412/mountainspeed2, ystart-90+mountain2offset*0.3)
	end
	
	--mountains @ back
	for i = -2, 2 do
		love.graphics.draw(mountains2, 412*i-math.mod(position+170, mountainspeed2)*412/mountainspeed2, ystart-80+mountain2offset)
	end
	
	--mountains @ front	
	for i = -2, 2 do
		love.graphics.draw(mountains1, 412*i-math.mod(position, mountainspeed1)*412/mountainspeed1, ystart-80)
	end
	
	--POLYGONS
	
	for i = -(verticallines+1), verticallines do
	
		--COLOR SELECTION
		
		if math.floor(math.mod(math.abs(position), 2)) == 1 then
			if math.mod(math.abs(i), 2) == 1 then
				love.graphics.setColor(unpack(color1))
			else
				love.graphics.setColor(unpack(color2))
			end
		else
			if math.floor(math.mod(math.abs(i), 2)) == 1 then
				love.graphics.setColor(unpack(color2))
			else
				love.graphics.setColor(unpack(color1))
			end
		end
			
		love.graphics.polygon("fill", ((windowwidth/2)-math.mod(position, 1) * upperwidth)+(i*upperwidth)+.5, ystart, ((windowwidth/2)-math.mod(position, 1) * upperwidth)+((i+1)*upperwidth)+.5, ystart,   ((windowwidth/2)-math.mod(position, 1) * lowerwidth)+((i+1)*lowerwidth)+.5, (windowheight*1.5) ,(windowwidth/2)-(math.mod(position, 1) * lowerwidth)+(i*lowerwidth)+.5, (windowheight*1.5) )
	end
	
	love.graphics.setColor(255, 255, 255, gradientalpha)
	
	love.graphics.draw(gradient, -180, ystart)
	
	love.graphics.setColor(unpack(linecolor))
	
	--HORIZONTAL LINES
	
	love.graphics.line(-(windowwidth/2), ystart, (windowwidth*1.5), ystart)
	for i = -3, 20 do
		y = getY(i)
		--love.graphics.setLine( i^2/30 * (10/height))
		love.graphics.line(-(windowwidth/2), y+ystart, (windowwidth*1.5), y+ystart)
	end
	
	--VERTICAL LINES
	
	love.graphics.setLine( 0.1 )
	for i = -verticallines, verticallines do
		love.graphics.line(((windowwidth/2)-math.mod(position, 1) * upperwidth)+(i*upperwidth)+.5, ystart, ((windowwidth/2)-math.mod(position, 1) * lowerwidth)+(i*lowerwidth)+.5, (windowheight*1.5))
	end
	
	--tree (test)
	for i = 1, 13 do
		if obstacletable[i] ~= nil then
			if getY(i)+ystart < windowheight*2 then
				love.graphics.draw(tree, getX(obstacletable[i] - position, getY(i)), getY(i)+ystart, 0, getY(i)/80+0.5, getY(i)/80+0.5, 17, 102)
			end
		end
	end
	
	--[[
	--(sexy) HUD (rotated)
	love.graphics.setColor(unpack(hudcolor))
	love.graphics.setScissor(30, 30, 580, 420)
	--love.graphics.setScissor(30*2.625, 30*2.1875, 580*2.625, 420*2.1875)--1680x1050]]--
	
	
	--Horizont oldrotation
	
	--anti-rotate	
    love.graphics.translate(windowwidth/2, 240)--ystart)
    love.graphics.rotate(-rotation)
    love.graphics.translate(-windowwidth/2, -240)---ystart)
	--rotate shit (old)
    love.graphics.translate(windowwidth/2, 240)--ystart)
    love.graphics.rotate(oldrotation)
    love.graphics.translate(-windowwidth/2, -240)---ystart)
	
	--Artificial horizont
	love.graphics.draw(hudhorizont, 320, 240, 0, 1, 1, 161.5, -oldystart+(ystartadd-windowheight/2)+665+((height/2)*ystartheightoffset))
	
	
	--anti-rotate (old)
    love.graphics.translate(windowwidth/2, 240)--ystart)
    love.graphics.rotate(-oldrotation)
    love.graphics.translate(-windowwidth/2, -240)---ystart)
	
	--HUD (unrotated)--
	love.graphics.draw(hudstatic, 0, 0)
	love.graphics.draw(hudheight, 487, round(-142+(height-10)*2))
	love.graphics.rectangle("fill", 501, 0, 2, round((height-10)*2-141))
	
	--height
	width = fontpure:getWidth( round(height) )
	r, g, b, a = unpack(hudcolor)
	if height < redstart then
		r = 255-(255-r)*((height-minheight)/(redstart-minheight))
		g = g *((height-minheight)/(redstart-minheight))
		b = b *((height-minheight)/(redstart-minheight))
	end
	love.graphics.setColor(r, g, b, a)
	love.graphics.print(round(height), 558-width, 225)
	love.graphics.setColor(unpack(hudcolor))
	
	--sidespeed indicator
	if sidespeed > 0 then
		love.graphics.rectangle("fill", 320, 424, sidespeed / maxsidespeed * 100, 16)
	elseif sidespeed < 0 then
		love.graphics.rectangle("fill", 319, 424, sidespeed / maxsidespeed * 100, 16)
	end
	
	--heightspeed indicator
	love.graphics.draw(hudjet, 549, 284, heightspeed/maxheightspeed*math.pi/5, 1, 1, 35, 12)
	if height < 30 then
		love.graphics.rectangle("fill", 510, 300+round(height), 84, 3)
	end
	
	love.graphics.setScissor()
	--DRAW END!
	
	love.graphics.setColor(255, 255, 255)
end

function love.keypressed(key)
	if key == "1" then
		obstacletable[1] = 1
	elseif key == "2" then
		obstacletable[1] = 2
	elseif key == "3" then
		obstacletable[1] = 3
	elseif key == "4" then
		obstacletable[1] = 4
	elseif key == "5" then
		obstacletable[1] = 5
	elseif key == "6" then
		obstacletable[1] = 6
	elseif key == "7" then
		obstacletable[1] = 7
	elseif key == "8" then
		obstacletable[1] = 8
	elseif key == "9" then
		obstacletable[1] = 9
	elseif key == "0" then
		obstacletable[1] = 0
	end
	
	if key == "left" and barrelroll == false then
		currenttime = love.timer.getTime()
		if currenttime - leftbarreltimer < barrelrolldelay then
			barrelroll = "left"
			barrelrolled = 0
		else
			leftbarreltimer = currenttime
		end
	end
	
	if key == "right" and barrelroll == false then
		currenttime = love.timer.getTime()
		if currenttime - rightbarreltimer < barrelrolldelay then
			barrelroll = "right"
			barrelrolled = 0
		else
			rightbarreltimer = currenttime
		end
	end
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end
function getX(pos, y)
	local minoff = (windowwidth/2)+(pos*upperwidth)
	local maxoff = (windowwidth/2)+(pos*lowerwidth) - (windowwidth/2)+(pos*upperwidth)
	local perc = y / (windowheight*1.5 - ystart)
	return minoff + (maxoff*perc)
end

function movetable()
	for i = 23, 2, -1 do
		obstacletable[i] = obstacletable[i-1]
	end
	obstacletable[1] = nil
end

function getY(coy)
	local out = 1
	out = out+out*(cellheight-1)*(math.mod(tick, speed)/speed)
	for i = 1, coy do
		out = out * cellheight
	end
	return out-1
end